<template>
  <v-container
    fluid
    class="fill-height"
    color="white"
  >
    <v-row
      justify="center"
      align="start"
      class="fill-height"
    >
      <v-col cols="12">
        <v-textarea
          v-model="source"
          outlined
          clearable
          label="Enter CSV question,answer or JSON {&quot;question&quot;: &quot;a question&quot;: &quot;answer&quot;: &quot;the answer&quot;}"
          @input="sourceChanged"
        />
      </v-col>
      <v-col
        cols="12"
        justify="center"
      >
        <v-btn
          v-if="source.length && !checkedFormating"
          color="success"
          size="small"
          rounded="xl"
          elevated
          stacked
          @click="checkFormating"
        >
          Step #1, Check Formating
        </v-btn>
        <v-btn
          v-if="source.length && checkedFormating"
          color="success"
          size="small"
          rounded="xl"
          elevated
          stacked
          @click="uploadQuestions"
        >
          Step #2, Upload Questions
        </v-btn>
      </v-col>
      <v-col cols="12">
        <div v-html="errors" />
      </v-col>
    </v-row>
  </v-container>
</template>

<script setup>
import { ref } from "vue"
import { post } from "aws-amplify/api"

let source = ref("")
let checkedFormating = ref(false)
let errors = ref("")
let questions

const sourceChanged = () => {
  checkedFormating.value = false
}

const checkObjectProperties = (requiredPropertyNames, object) => {
  let errors = []

  for(const name in object) {
    const value = object[name]

    if(requiredPropertyNames.includes(name) === false) {
      errors.push(`${name} is not allowed`)
    }

    if(typeof value !== "string") {
      errors.push(`${value} is not a string`)
    }
  }

  for(const name of requiredPropertyNames) {
    if(object[name] === undefined) {
      errors.push(`missing "${name}"`)
    }
  }

  if(errors.length) {
    errors.push(`<span>    </span>in ${JSON.stringify(object)}`)
  }

  return errors
}

const checkFormating = () => {
  console.log(source.value)
  const lines = source.value.split("\n")
  questions = []

  errors.value = ""

  for(let line of lines) {
    line = line.trim()

    if(line[0] == "{") {
      try {
        //const question = eval(line)
        const question = JSON.parse(line)
        const arrayOfErrors = checkObjectProperties(["answer", "question"], question)
        
        if(arrayOfErrors.length === 0) {
          questions.push(question)
        } else {
          errors.value += arrayOfErrors.join("<br />")
        }
      } catch(error) {
        errors.value += `${line} is not valid JSON<br />`
      }
    } else {
      const qAnda = line.split(",")

      if(qAnda.length !== 2) {
        errors.value += `${qAnda.length} columns found in ${line}<br />`
      } else {
        questions.push({
          question:qAnda[0].trim(),
          answer:qAnda[1].trim()
        })
      }
    }
    
    if(errors.value === "") {
      source.value = JSON.stringify(questions, undefined, "    ")
      checkedFormating.value = true
    }
  }
}

const uploadQuestions = async  () => {
  try{
    const restOperation = post({
      apiName: "fanfesttrivia",
      path: "/trivia/questions",
      options: {
        body: questions
      }
    })

    const { body } = await restOperation.response
    const response = await body.json()
    console.log("POST call succeeded")
    console.log(response)
  } catch (error) {
    console.error(error)
  }

  source.value = ""
}

</script>